/*
 * Marcin Owsiany 8:00
 * 3 18.11.2000
 * 5 6
 */

#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <signal.h>
#include <stdio.h>
#include <fcntl.h>
#include <time.h>

int fd, i = 1;
pid_t p;
char *znak;

void do_write(int foo)
{
	signal(SIGUSR1, do_write);
	if (i >= 6) return;
	if (write(fd, znak, 1) != 1) {
		perror("write");
		exit(EXIT_FAILURE);
	} else
		i++;
}

int main(int argc, char **argv)
{
/*	timespec foo, bar;
	foo.tv_sec = 0;
	foo.tv_nsec = 1;
*/
	if (argc != 2) {
		fprintf(stderr, "Wymagany jeden parametr: nazwa pliku\n");
		exit(EXIT_FAILURE);
	}
	if ((fd = open(argv[1], O_EXCL|O_WRONLY|O_CREAT, 0640)) == -1) {
		perror(argv[1]);
		exit(EXIT_FAILURE);
	}
	if ((p = fork()) == -1) {
		perror("fork()");
		exit(EXIT_FAILURE);
	}
	signal(SIGUSR1, do_write);
	if (p == 0) {		/*** P2 ***/
		znak = "b";
		p = getppid();
		while (i < 6) {
			pause();
/*			nanosleep(&foo, &bar);*/
			kill(p, SIGUSR1);
		}
	} else {		/*** P1 ***/
		znak = "a";
		sleep(2); /* give P2 a chance to initialize */
		do_write(0);
		while (i < 6) {
			kill(p, SIGUSR1);
			pause();
/*			nanosleep(&foo, &bar);*/
		}
		kill(p, SIGUSR1);
		close(fd);
	}
	exit(0);
}
