/*
 * Marcin Owsiany 8:00
 * 3 18.11.2000
 * 6 6
 */

#include <stdio.h>
#include <stdlib.h>
#include "my_popen.h"

#define SIZE 512
char buff[SIZE];

int main(int argc, char **argv)
{
	int n;
	FILE *f, *g;

	if (argc != 3) {
		fprintf(stderr, "Wymagane dwa argumenty: nazwy programow\n");
		exit(EXIT_FAILURE);
	}

	g = popen(argv[1], "r");
	if (g == NULL) {
		perror(argv[1]);
		exit(EXIT_FAILURE);
	}
	f = popen(argv[2], "w");
	if (f == NULL) {
		perror(argv[2]);
		exit(EXIT_FAILURE);
	}
	while ((n = fread(buff, 1, SIZE, g)) > 0)
		if (fwrite(buff, 1, n, f) != n) {
			perror("fwrite");
			exit(1);
		}
	pclose(g);
	pclose(f);
	exit(0);
}
